/*                  PARTICUL.INC for POVRAY 3.1
                    GEMELLI David
                    Version 2.1         9 janvier 1999

     For more details (in a readable english I hope) see PARTICUL.DOC
*/
// Animation: active (1) ou non (0) l'animation (0)
// Animation_Type:
// 0 => explosion constante
//        definir la vitesse: Vitesse, pas de deplacement
//        definir le centre: Centre_X, Centre_Y, Centre_Z
// 1 => explosion aleatoire
//        definir la vitesse maxi: Vitesse_Maxi, pas de deplacement maxi
//        definir la vitesse mini: Vitesse_Mini, pas de deplacement mini
//        definir le centre: Centre_X, Centre_Y, Centre_Z
// 2 => translation constante
//        definir le vecteur vitesse: Translation_X, Translation_Y,
//        Translation_Z
// 3 => translation aleatoire
//        definir le vecteur vitesse mini: Translation_X_Min,
//        Translation_Y_Min, Translation_Z_Min (0)
//        definir le vecteur vitesse maxi: Translation_X_Max,
//        Translation_Y_Max, Translation_Z_Max (1)
// 4 => rotation constante
//        definir les angles de rotation: Rotation_X, Rotation_Y, Rotation_Z
//        definir le centre de rotation: Centre_X, Centre_Y, Centre_Z
// 5 => rotation aleatoire
//        definir les angles de rotation maxi: Rotation_X_Max,
//        Rotation_Y_Max, Rotation_Z_Max (10)
//        definir les angles de rotation mini: Rotation_X_Min,
//        Rotation_Y_Min, Rotation_Z_Min (0)
//        definir le centre de rotation: Centre_X, Centre_Y, Centre_Z
// 6 => rotation variable
//        definir les angles de rotation maxi: Rotation_X_Max,
//        Rotation_Y_Max, Rotation_Z_Max
//        definir le centre de rotation: Centre_X, Centre_Y, Centre_Z
//        definir la macro M_RVariation
//        parametres en entree : dista, hauteur (0-1) , initialx, initialy, 
//             initialz (Rotation_X_Max, Rotation_Y_Max, Rotation_Z_Max), 
//             retourx, retoury, retourz
//        valeur en sortie: les angles pour cette hauteur et cette distance
//        ex:
//        #macro M_RVariation(dista, hauteur, initialx, initialy, initialz, 
//             retourx, retoury, retourz)
//             #declare retourx = initialx + (pow(hauteur, 2) * 20) - (dista * 4);
//             #declare retoury = 0;
//             #declare retourz = 10;
//        #end
// Rot_Random: rotation aleatoire de la particule (0)
// 0 => rotation inactive
// 1 => rotation active
// Scale_Random: scaling aleatoire de la particule (0)
// 0 => inactive
// 1 => active
//        definir le rayon min et max:
//        Scale_Particule_Min, Scale_Particule_Max
// Rot_Anim: rotation continue lors de l'animation (0)
// 0 => rotation inactive
// 1 => rotation active
//        definir l'angle en X: R_Angle_X
//        definir l'angle en Y: R_Angle_Y
//        definir l'angle en Z: R_Angle_Z
// Rayon_Particule: rayon des spheres (0.1)
// Objet_Particule: particule (par defaut une sphere)
// Forme: forme de la zone a remplir (2 Cube)
// 0 => Sphere: Rayon (10)
// 1 => Cylindre: Rayon (5), Hauteur (10)
// 2 => Cube: Taille (10)
// 3 => Cone: Rayon_Bas (0), Rayon_Haut (5), Hauteur (10)
// Nb_Couches: nombre de couches (5)
// PMax: nombre maxi de particules par couche (20)
// PVariation: variation du nombre de particules (de bas en haut) (0)
// 0 => variation inactive
// 1 => variation active:
//        definir une macro M_PVariation
//        parametres en entree : hauteur (0-1) , initial (PMax), retour
//        valeur en sortie: le nombre de paticules pour cette hauteur
//        ex:
//        #macro M_PVariation(hauteur, initial, retour)
//             #declare retour = initial + (pow(hauteur, 2) * 20);
//        #end
// Offset: variation aleatoire maximale de la hauteur (0)
// EVariation: variation de l'ecart (de bas en haut) (0)
// 0 => ecart constant
// 1 => ecart variable:
//        definir une macro M_EVariation
//        parametres en entree : hauteur (0-1) , initial (EMax), retour
//        valeur en sortie: la distance pour cette hauteur
//        ex:
//        #macro M_EVariation(hauteur, initial, retour)
//             #declare retour = initial + ((hauteur / 2) * 20);
//        #end
// EMax: ecart maxi entre le centre du volume et le remplissage (0)
// E2Variation: variation de l'ecart (de bas en haut) (0)
// 0 => ecart constant
// 1 => ecart variable:
//        definir une macro M_E2Variation
//        parametres en entree : hauteur (0-1) , initial (EMax), retour
//        valeur en sortie: la distance pour cette hauteur
//        ex:
//        #macro M_E2Variation(hauteur, initial, retour)
//             #declare retour = initial + ((hauteur / 2) * 20);
//        #end
// E2Max: ecart maxi entre le remplissage de base et la surface (0)
// Anti_Collision: creer des particules qui ne se touchent pas (0)
// 0 => inactif
// 1 => actif (long 'parsing')
// Resultat:
// un objet 'Particules': union de toutes les particules
// un objet 'Container': forme a remplir

#declare Forme_Sphere = 0;
#declare Forme_Cylindre = 1;
#declare Forme_Cube = 2;
#declare Forme_Cone = 3;
#local Seed0 = seed(21564);
#local Seed1 = seed(79523);
#local Seed2 = seed(85760);
#local Eps = 0.001;
#declare retour = 0;

// test des variables de parametrage
#ifndef (Animation)
     #local Animation = 0;
     #local R_Angle_X = 0;
     #local R_Angle_Y = 0;
     #local R_Angle_Z = 0;
     #local Rot_Anim = 0;
#else
     #if (Animation = 1)
          #debug "Animation activee\n"
          #ifndef (Animation_Type)
               #debug "Animation_Type indefinie, valeur par defaut 0\n"
               #local Animation_Type = 0;
          #end
          #ifndef (Rot_Anim)
               #debug "Rot_Anim indefinie, valeur par defaut 0 (inactif)\n"
               #local Rot_Anim = 0;
          #end
          #if (Rot_Anim = 1)
               #ifndef (R_Angle_X)
                    #debug "R_Angle_X indefinie, valeur par defaut 0\n"
                    #local R_Angle_X = 0;
               #end
               #ifndef (R_Angle_Y)
                    #debug "R_Angle_Y indefinie, valeur par defaut 0\n"
                    #local R_Angle_Y = 0;
               #end
               #ifndef (R_Angle_Z)
                    #debug "R_Angle_Z indefinie, valeur par defaut 0\n"
                    #local R_Angle_Z = 0;
               #end
          #end
     #end
#end
#ifndef (Scale_Random)
     #debug "Scale_Random indefinie, valeur par defaut 0 (inactif)\n"
     #local Scale_Random = 0;
#end
#if (Scale_Random = 1)
     #ifndef (Scale_Particule_Min)
          #debug "Scale_Particule_Min indefinie, valeur par defaut 1\n"
          #local Scale_Particule_Min = 1;
     #end
     #ifndef (Scale_Particule_Max)
          #debug "Scale_Particule_Max indefinie, valeur par defaut 1\n"
          #local Scale_Particule_Max = 1;
     #end
#end
#ifndef (Rayon_Particule)
     #debug "Rayon_particule indefinie, valeur par defaut 0.1\n"
     #local Rayon_Particule = 0.1;
#else
     #if (Rayon_Particule <= 0)
          #debug "Rayon_particule non valide, valeur par defaut 0.1\n"
          #local Rayon_Particule = 0.1;
     #end
#end
#ifndef (Objet_Particule)
     #debug "Objet_Particule indefinie, objet par defaut\n"
     #local Objet_Particule = sphere {<0, 0, 0>, Rayon_Particule}
#end
#ifndef (Rot_Random)
     #debug "Rot_Random indefinie, valeur par defaut 0 (inactif)\n"
     #local Rot_Random = 0;
#end
#ifndef (Forme)
     #debug "Forme indefinie, valeur par defaut 2 (Cube)\n"
     #local Forme = 2;
#end
#ifndef (Nb_Couches)
     #debug "Nb_Couches indefinie, valeur par defaut 5\n"
     #local Nb_Couches = 5;
#else
     #if (Nb_Couches <= 0)
          #debug "Nb_Couches non valide, valeur par defaut 5\n"
          #local Nb_Couches = 5;
     #end
#end
#ifndef (PMax)
     #debug "PMax indefinie, valeur par defaut 20\n"
     #local PMax = 20;
#else
     #if (PMax <= 0)
          #debug "PMax non valide, valeur par defaut 20\n"
          #local PMax = 20;
     #end
#end
#ifndef (PVariation)
     #debug "PVariation indefinie, valeur par defaut 0 (inactif)\n"
     #local PVariation = 0;
#end
#ifndef (M_PVariation)
     #if (PVariation = 1)
          #debug "M_PVariation indefinie, macro par defaut\n"
     #end
     #macro M_PVariation(hauteur, initial, retour)
          #declare retour = initial;
     #end
#end
#ifndef (Offset)
     #debug "Offset indefinie, valeur par defaut 0\n"
     #local Offset = 0;
#end
#ifndef (EVariation)
     #debug "EVariation indefinie, valeur par defaut 0 (inactif)\n"
     #local EVariation = 0;
#end
#ifndef (EMax)
     #if (EVariation = 1)
          #debug "EMax indefinie, valeur par defaut 0\n"
     #end
     #local EMax = 0;
#end
#ifndef (M_EVariation)
     #if (EVariation = 1)
          #debug "M_EVariation indefinie, macro par defaut\n"
     #end
     #macro M_EVariation(hauteur, initial, retour)
          #declare retour = initial;
     #end
#end
#ifndef (E2Variation)
     #debug "E2Variation indefinie, valeur par defaut 0 (inactif)\n"
     #local E2Variation = 0;
#end
#ifndef (E2Max)
     #if (E2Variation = 1)
          #debug "E2Max indefinie, valeur par defaut 0\n"
     #end
     #local E2Max = 0;
#end
#ifndef (M_E2Variation)
     #if (E2Variation = 1)
          #debug "Macro M_E2Variation indefinie, macro par defaut\n"
     #end
     #macro M_E2Variation(hauteur, initial, retour)
          #declare retour = initial;
     #end
#end
#ifndef (Anti_Collision)
     #debug "Anti_Collision indefinie, valeur par defaut 0 (pas de test)\n"
     #local Anti_Collision = 0;
#end

#local Tab = array[7][Nb_Couches][PMax]

// pas d'animation ou premiere image de l'animation
#if ((Animation = 0)|((Animation = 1)&(!file_exists("particul.tmp"))))

// generation des particules
#local IndC = 0;
#while (IndC < Nb_Couches)
     #local IndC2 = IndC + 0.5;
     #debug "Couche:"
     #debug str(IndC + 1, 3, 0)
     #debug "/"
     #debug str(Nb_Couches, 3, 0)
     #local valid = 0;
     #local start = 1;
     #local Ind = 0;
     #local Ind2 = 0;
     M_PVariation(IndC / Nb_Couches, PMax, retour)
     #local retourP = retour;
     #debug "    Nb particules:"
     #debug str(retourP, 5, 0)
     #debug "\n"
     #while (Ind < retourP)
          M_EVariation(IndC / Nb_Couches, EMax, retour)
          #local ecarttmp = retour;
          M_E2Variation(IndC / Nb_Couches, E2Max, retour)
          #local ecart2tmp = retour;
          #if (valid = 0)
               #switch (Forme)
                    #case(Forme_Sphere)
                         #ifndef (Rayon)
                              #debug "Rayon de la zone indefini, valeur par defaut 10\n"
                              #local Rayon = 10;
                         #end
                         #local alpha1 = radians(360 * rand(Seed0));
                         #local rayontmp = Rayon * sin (radians ((IndC2 / Nb_Couches) * 180));
                         #local rayontmp = ecarttmp + ((ecart2tmp + rayontmp - ecarttmp) * rand(Seed1));
                         #local InterC =  Rayon * 2 / Nb_Couches;
                         #local Tab[0][IndC][Ind] = rayontmp * cos(alpha1);
                         #local Tab[1][IndC][Ind] = (-Rayon) + (IndC2 * InterC) + (Offset * rand(Seed2)) - (Offset / 2);
                         #local Tab[2][IndC][Ind] = rayontmp * sin(alpha1);
                         #declare Container =
                         sphere {
                              <0, 0, 0>, Rayon
                         }
                    #break
                    #case(Forme_Cylindre)
                         #ifndef (Rayon)
                              #debug "Rayon de la zone indefini, valeur par defaut 5\n"
                              #local Rayon = 5;
                         #end
                         #ifndef (Hauteur)
                              #debug "Hauteur de la zone indefinie, valeur par defaut 10\n"
                              #local Hauteur = 10;
                         #end
                         #local alpha1 = radians(360 * rand(Seed0));
                         #local rayontmp = ecarttmp + ((ecart2tmp + Rayon - ecarttmp) * rand(Seed1));
                         #local InterC =  Hauteur / Nb_Couches;
                         #local Tab[0][IndC][Ind] = rayontmp * cos(alpha1);
                         #local Tab[1][IndC][Ind] = (-Hauteur / 2) + (IndC2 * InterC) + (Offset * rand(Seed2)) - (Offset / 2);
                         #local Tab[2][IndC][Ind] = rayontmp * sin(alpha1);
                         #declare Container =
                         cylinder {
                              <0, -Hauteur / 2, 0>,
                              <0, Hauteur / 2, 0>, Rayon
                         }
                    #break
                    #case(Forme_Cube)
                         #ifndef (Taille)
                              #debug "Taille de la zone indefinie, valeur par defaut 10\n"
                              #local Taille = 10;
                         #end
                         #local InterC = Taille / Nb_Couches;
                         #local Tab[0][IndC][Ind] = ecarttmp + (((ecart2tmp + Taille - ecarttmp) * rand(Seed0)) - (Taille / 2));
                         #local Tab[1][IndC][Ind] = (-Taille / 2) + (IndC2 * InterC) + (Offset * rand(Seed1)) - (Offset / 2);
                         #local Tab[2][IndC][Ind] = ecarttmp + (((ecart2tmp + Taille - ecarttmp) * rand(Seed2)) - (Taille / 2));
                         #declare Container =
                         box {
                              <-Taille / 2, -Taille / 2, -Taille / 2>,
                              <Taille / 2, Taille / 2, Taille / 2>
                         }
                    #break
                    #case(Forme_Cone)
                         #ifndef (Rayon_Bas)
                              #debug "Rayon bas de la zone indefini, valeur par defaut 0\n"
                              #local Rayon_Bas = 0;
                         #end
                         #ifndef (Rayon_Haut)
                              #debug "Rayon haut de la zone indefini, valeur par defaut 5\n"
                              #local Rayon_Haut = 5;
                         #end
                         #ifndef (Hauteur)
                              #debug "Hauteur de la zone indefinie, valeur par defaut 10\n"
                              #local Hauteur = 10;
                         #end
                         #local InterR = (Rayon_Haut - Rayon_Bas) / Nb_Couches;
                         #local InterC = Hauteur / Nb_Couches;
                         #local rayontmp = Rayon_Bas + (InterR * IndC2);
                         #local alpha1 = radians(360 * rand(Seed0));
                         #local rayontmp = ecarttmp + ((ecart2tmp + rayontmp - ecarttmp) * rand(Seed1));
                         #local Tab[0][IndC][Ind] = rayontmp * cos(alpha1);
                         #local Tab[1][IndC][Ind] = (-Hauteur / 2) + (IndC2 * InterC) + (Offset * rand(Seed2)) - (Offset / 2);
                         #local Tab[2][IndC][Ind] = rayontmp * sin(alpha1);
                         #declare Container =
                         cone {
                              <0, -Hauteur / 2, 0>, Rayon_Bas,
                              <0, Hauteur / 2, 0>, Rayon_Haut
                         }
                    #break
               #end
               #if (Rot_Random = 1)
                    #local Tab[3][IndC][Ind] = 360 * rand(Seed0);
                    #local Tab[4][IndC][Ind] = 360 * rand(Seed1);
                    #local Tab[5][IndC][Ind] = 360 * rand(Seed2);
               #else
                    #local Tab[3][IndC][Ind] = 0;
                    #local Tab[4][IndC][Ind] = 0;
                    #local Tab[5][IndC][Ind] = 0;
               #end
          #end
          #if ((Scale_Random = 1)&(Ind2 = 0))
               #local Tab[6][IndC][Ind] = Scale_Particule_Min + ((Scale_Particule_Max - Scale_Particule_Min) * rand(Seed0));
          #else
               #if (Scale_Random = 0)
                    #local Tab[6][IndC][Ind] = 1;
               #end
          #end
          #if (Anti_Collision = 0)
               #local Ind2 = Ind;
          #else
               #if (start = 0)
                    #local rpx = Tab[0][IndC][Ind];
                    #local rpy = Tab[1][IndC][Ind];
                    #local rpz = Tab[2][IndC][Ind];
                    #local rpx2 = Tab[0][IndC][Ind2];
                    #local rpy2 = Tab[1][IndC][Ind2];
                    #local rpz2 = Tab[2][IndC][Ind2];
                    #local dist = sqrt(pow(rpx2-rpx,2)+pow(rpy2-rpy,2)+pow(rpz2-rpz,2));
                    #if (dist > (Rayon_Particule*(Tab[6][IndC][Ind]+Tab[6][IndC][Ind2])))
                         #local valid = 1;
                    #else
                         #local valid = 0;
                    #end
                    #if (valid = 1)
                         #local Ind2 = Ind2 + 1;
                    #else
                         #local Ind2 = 0;
                    #end
               #else
                    #local start = 0;
               #end
          #end
          #if (Ind2 = Ind)
               #local Ind = Ind + 1;
               #local Ind2 = 0;
               #local valid = 0;
          #end
     #end
     #local IndC = IndC + 1;
     M_PVariation(IndC / Nb_Couches, PMax, retour)
     #local retourP = retour;
#end
#else     // animation active et fichier deja cree
     #local Tab = array[7][Nb_Couches][PMax]
     // lecture du fichier
     #fopen The_File "particul.tmp" read
     #read (The_File, Img, Tmp0, Tmp1, Tmp2, Tmp3, Tmp4)
     #debug "Image n"
     #debug str(Img, 4, 0)
     #debug "\n"
     #local Rayon = Tmp0;
     #local Hauteur = Tmp1;
     #local Taille = Tmp2;
     #local Rayon_Bas = Tmp3;
     #local Rayon_Haut = Tmp4;
     // lecture des positions et calcul des nouvelles positions
     #local IndC = 0;
     #while (IndC < Nb_Couches)
          #local Ind = 0;
          M_PVariation(IndC / Nb_Couches, PMax, retour)
          #while (Ind < retour)
               #read (The_File, Tmp0, Tmp1, Tmp2, Tmp3, Tmp4, Tmp5, Tmp6)
               #local Tab[0][IndC][Ind] = Tmp0;
               #local Tab[1][IndC][Ind] = Tmp1;
               #local Tab[2][IndC][Ind] = Tmp2;
               #local Tab[3][IndC][Ind] = Tmp3;
               #local Tab[4][IndC][Ind] = Tmp4;
               #local Tab[5][IndC][Ind] = Tmp5;
               #local Tab[6][IndC][Ind] = Tmp6;
               // calculs
               #if ((Animation_Type < 2)|(Animation_Type > 3))
                    #ifndef (Centre_X)
                         #debug "Centre_X indefinie, valeur par defaut 0\n"
                         #local Centre_X = 0;
                    #end
                    #ifndef (Centre_Y)
                         #debug "Centre_Y indefinie, valeur par defaut 0\n"
                         #local Centre_Y = 0;
                    #end
                    #ifndef (Centre_X)
                         #debug "Centre_Z indefinie, valeur par defaut 0\n"
                         #local Centre_Z = 0;
                    #end
               #end
               #local Tmp00 = Tmp0 - Centre_X;
               #local Tmp11 = Tmp1 - Centre_Y;
               #local Tmp22 = Tmp2 - Centre_Z;
               #local dist = sqrt((Tmp00*Tmp00)+(Tmp11*Tmp11)+(Tmp22*Tmp22));
               #if (dist < Eps)
                    #local bet = 0;
                    #local alp = 0;
                    #local dist = 0;
               #else
                    #local alp = atan2(Tmp22, Tmp00);
                    #local d2 = sqrt((Tmp00*Tmp00)+(Tmp22*Tmp22));
                    #local bet = atan2(Tmp11, d2);
               #end
               #if (Animation_Type = 4)
                    #ifndef (Rotation_X)
                         #debug "Rotation_X indefinie, valeur par defaut 0\n"
                         #local Rotation_X = 0;
                    #end
                    #ifndef (Rotation_Y)
                         #debug "Rotation_Y indefinie, valeur par defaut 0\n"
                         #local Rotation_Y = 0;
                    #end
                    #ifndef (Rotation_Z)
                         #debug "Rotation_Z indefinie, valeur par defaut 0\n"
                         #local Rotation_Z = 0;
                    #end
                    #local sy = sin(radians(Rotation_Y));
                    #local sz = sin(radians(Rotation_X));
                    #local sx = sin(radians(Rotation_Z));
                    #local cy = cos(radians(Rotation_Y));
                    #local cz = cos(radians(Rotation_X));
                    #local cx = cos(radians(Rotation_Z));
               #end
               #if (Animation_Type = 5)
                    #ifndef (Rotation_X_Max)
                         #debug "Rotation_X_Max indefinie, valeur par defaut 10\n"
                         #local Rotation_X_Max = 10;
                    #end
                    #ifndef (Rotation_Y_Max)
                         #debug "Rotation_Y_Max indefinie, valeur par defaut 10\n"
                         #local Rotation_Y_Max = 10;
                    #end
                    #ifndef (Rotation_Z_Max)
                         #debug "Rotation_Z_Max indefinie, valeur par defaut 10\n"
                         #local Rotation_Z_Max = 10;
                    #end
                    #ifndef (Rotation_X_Min)
                         #debug "Rotation_X_Min indefinie, valeur par defaut 0\n"
                         #local Rotation_X_Min = 0;
                    #end
                    #ifndef (Rotation_Y_Min)
                         #debug "Rotation_Y_Min indefinie, valeur par defaut 0\n"
                         #local Rotation_Y_Min = 0;
                    #end
                    #ifndef (Rotation_Z_Min)
                         #debug "Rotation_Z_Min indefinie, valeur par defaut 0\n"
                         #local Rotation_Z_Min = 0;
                    #end
                    #local roty = Rotation_Y_Min+((Rotation_Y_Max-Rotation_Y_Min)*rand(Seed0));
                    #local rotz = Rotation_X_Min+((Rotation_X_Max-Rotation_X_Min)*rand(Seed1));
                    #local rotx = Rotation_Z_Min+((Rotation_Z_Max-Rotation_Z_Min)*rand(Seed2));
                    #local sy = sin(radians(roty));
                    #local sz = sin(radians(rotx));
                    #local sx = sin(radians(rotz));
                    #local cy = cos(radians(roty));
                    #local cz = cos(radians(rotx));
                    #local cx = cos(radians(rotz));
               #end
               #if (Animation_Type = 6)
                    #ifndef (Rotation_X_Max)
                         #debug "Rotation_X_Max indefinie, valeur par defaut 0\n"
                         #local Rotation_X_Max = 0;
                    #end
                    #ifndef (Rotation_Y_Max)
                         #debug "Rotation_Y_Max indefinie, valeur par defaut 0\n"
                         #local Rotation_Y_Max = 0;
                    #end
                    #ifndef (Rotation_Z_Max)
                         #debug "Rotation_Z_Max indefinie, valeur par defaut 0\n"
                         #local Rotation_Z_Max = 0;
                    #end
                    #ifndef (M_RVariation)
                         #debug "Macro M_RVariation indefinie, macro par defaut\n"
                         #macro M_RVariation(dista, hauteur, initialx, initialy, initialz, retourx, retoury, retourz)
                              #declare retourx = initialx;
                              #declare retoury = initialy;
                              #declare retourz = initialz;
                         #end
                    #end
                    #declare retourx = Rotation_X_Max;
                    #declare retoury = Rotation_Y_Max;
                    #declare retourz = Rotation_Z_Max;
                    M_RVariation(dist,IndC / Nb_Couches, retourx, retoury, retourz, retourx, retoury, retourz)
                    #local sy = sin(radians(retoury));
                    #local sz = sin(radians(retourx));
                    #local sx = sin(radians(retourz));
                    #local cy = cos(radians(retoury));
                    #local cz = cos(radians(retourx));
                    #local cx = cos(radians(retourz));
               #end
               #switch (Animation_Type)
                    #case (0)
                         #ifndef (Vitesse)
                              #debug "Vitesse indefinie, valeur par defaut 1\n"
                              #local Vitesse = 1;
                         #end
                         #local dist = dist + Vitesse;
                         #local Tab[1][IndC][Ind] = (dist * sin(bet)) + Centre_Y;
                         #local d2 = dist * cos(bet);
                         #local Tab[0][IndC][Ind] = (d2 * cos(alp)) + Centre_X;
                         #local Tab[2][IndC][Ind] = (d2 * sin(alp)) + Centre_Z;
                    #break
                    #case (1)
                         #ifndef (Vitesse_Maxi)
                              #debug "Vitesse_Maxi indefinie, valeur par defaut 1\n"
                              #local Vitesse_Maxi = 1;
                         #end
                         #ifndef (Vitesse_Mini)
                              #debug "Vitesse_Mini indefinie, valeur par defaut 0\n"
                              #local Vitesse_Mini = 0;
                         #end
                         #local dist = dist + Vitesse_Mini + ((Vitesse_Maxi - Vitesse_Mini) * rand(Seed0));
                         #local Tab[1][IndC][Ind] = (dist * sin(bet)) + Centre_Y;
                         #local d2 = dist * cos(bet);
                         #local Tab[0][IndC][Ind] = (d2 * cos(alp)) + Centre_X;
                         #local Tab[2][IndC][Ind] = (d2 * sin(alp)) + Centre_Z;
                    #break
                    #case (2)
                         #ifndef (Translation_X)
                              #debug "Translation_X indefinie, valeur par defaut 0\n"
                              #local Translation_X = 0;
                         #end
                         #ifndef (Translation_Y)
                              #debug "Translation_Y indefinie, valeur par defaut 0\n"
                              #local Translation_Y = 0;
                         #end
                         #ifndef (Translation_Z)
                              #debug "Translation_Z indefinie, valeur par defaut 0\n"
                              #local Translation_Z = 0;
                         #end
                         #local Tab[0][IndC][Ind] = Tab[0][IndC][Ind] + Translation_X;
                         #local Tab[1][IndC][Ind] = Tab[1][IndC][Ind] + Translation_Y;
                         #local Tab[2][IndC][Ind] = Tab[2][IndC][Ind] + Translation_Z;
                    #break
                    #case (3)
                         #ifndef (Translation_X_Min)
                              #debug "Translation_X_Min indefinie, valeur par defaut 0\n"
                              #local Translation_X_Min = 0;
                         #end
                         #ifndef (Translation_Y_Min)
                              #debug "Translation_Y_Min indefinie, valeur par defaut 0\n"
                              #local Translation_Y_Min = 0;
                         #end
                         #ifndef (Translation_Z_Min)
                              #debug "Translation_Z_Min indefinie, valeur par defaut 0\n"
                              #local Translation_Z_Min = 0;
                         #end
                         #ifndef (Translation_X_Max)
                              #debug "Translation_X_Max indefinie, valeur par defaut 1\n"
                              #local Translation_X_Max = 1;
                         #end
                         #ifndef (Translation_Y_Max)
                              #debug "Translation_Y_Max indefinie, valeur par defaut 1\n"
                              #local Translation_Y_Max = 1;
                         #end
                         #ifndef (Translation_Z_Max)
                              #debug "Translation_Z_Max indefinie, valeur par defaut 1\n"
                              #local Translation_Z_Max = 1;
                         #end
                         #local Tab[0][IndC][Ind] = Tab[0][IndC][Ind] + Translation_X_Min + ((Translation_X_Max-Translation_X_Min)*Rand(Seed0));
                         #local Tab[1][IndC][Ind] = Tab[1][IndC][Ind] + Translation_Y_Min + ((Translation_Y_Max-Translation_Y_Min)*Rand(Seed1));
                         #local Tab[2][IndC][Ind] = Tab[2][IndC][Ind] + Translation_Z_Min + ((Translation_Z_Max-Translation_Z_Min)*Rand(Seed2));
                    #break
                    #case (4)
                         #local xx = Tmp00;
                         #local yy = Tmp11;
                         #local zz = Tmp22;
                         #local Tab[0][IndC][Ind] = (xx*((cx*cy)+(sx*sy*sz)))-(yy*((sx*cy)+(cx*sy*sz)))+(zz*(sy*cz))+Centre_X;
                         #local Tab[1][IndC][Ind] = (xx*(sx*cz))+(yy*(cx*cz))-(zz*(sz))+Centre_Y;
                         #local Tab[2][IndC][Ind] = (-xx*((cx*sy)+(sx*cy*sz)))+(yy*((sx*sy)+(cx*cy*sz)))+(zz*(cy*cz))+Centre_Z;
                    #break
                    #case (5)
                         #local xx = Tmp00;
                         #local yy = Tmp11;
                         #local zz = Tmp22;
                         #local Tab[0][IndC][Ind] = (xx*((cx*cy)+(sx*sy*sz)))-(yy*((sx*cy)+(cx*sy*sz)))+(zz*(sy*cz))+Centre_X;
                         #local Tab[1][IndC][Ind] = (xx*(sx*cz))+(yy*(cx*cz))-(zz*(sz))+Centre_Y;
                         #local Tab[2][IndC][Ind] = (-xx*((cx*sy)+(sx*cy*sz)))+(yy*((sx*sy)+(cx*cy*sz)))+(zz*(cy*cz))+Centre_Z;
                    #break
                    #case (6)
                         #local xx = Tmp00;
                         #local yy = Tmp11;
                         #local zz = Tmp22;
                         #local Tab[0][IndC][Ind] = (xx*((cx*cy)+(sx*sy*sz)))-(yy*((sx*cy)+(cx*sy*sz)))+(zz*(sy*cz))+Centre_X;
                         #local Tab[1][IndC][Ind] = (xx*(sx*cz))+(yy*(cx*cz))-(zz*(sz))+Centre_Y;
                         #local Tab[2][IndC][Ind] = (-xx*((cx*sy)+(sx*cy*sz)))+(yy*((sx*sy)+(cx*cy*sz)))+(zz*(cy*cz))+Centre_Z;
                    #break
                    // ...
               #end
               #if (Rot_Anim = 1)
                    #local Tab[3][IndC][Ind] = Tab[3][IndC][Ind] + R_Angle_X;
                    #local Tab[4][IndC][Ind] = Tab[4][IndC][Ind] + R_Angle_Y;
                    #local Tab[5][IndC][Ind] = Tab[5][IndC][Ind] + R_Angle_Z;
               #end
               #local Ind = Ind + 1;
          #end
          #local IndC = IndC + 1;
          M_PVariation(IndC / Nb_Couches, PMax, retour)
     #end
     #fclose The_File
#end

#if (Animation = 1)
     // variables a sauver:
     // Img, Rayon, Hauteur, Taille, Rayon_Bas, Rayon_Haut
     #ifndef (Img)
          #local Img = 0;
     #end
     #ifndef (Rayon)
          #local Rayon = 0;
     #end
     #ifndef (Hauteur)
          #local Hauteur = 0;
     #end
     #ifndef (Taille)
          #local Taille = 0;
     #end
     #ifndef (Rayon_Bas)
          #local Rayon_Bas = 0;
     #end
     #ifndef (Rayon_Haut)
          #local Rayon_Haut = 0;
     #end
     #fopen The_File "particul.tmp" write
     #write (The_File, Img + 1, ",", Rayon, ",", Hauteur, ",", Taille, ",",
          Rayon_Bas, ",", Rayon_Haut, ",")
#end

// L'objet Particules
#declare Particules =
union {
     #local IndC = 0;
     #while (IndC < Nb_Couches)
          #local Ind = 0;
          M_PVariation(IndC / Nb_Couches, PMax, retour)
          #while (Ind < retour)
               object {
                    Objet_Particule
                    scale Tab[6][IndC][Ind]
                    rotate <Tab[3][IndC][Ind], Tab[4][IndC][Ind], Tab[5][IndC][Ind]>
                    translate <Tab[0][IndC][Ind], Tab[1][IndC][Ind], Tab[2][IndC][Ind]>
               }
               #if (Animation = 1)
                    #write (The_File, Tab[0][IndC][Ind], ",",
                         Tab[1][IndC][Ind], ",", Tab[2][IndC][Ind], ",",
                         Tab[3][IndC][Ind], ",", Tab[4][IndC][Ind], ",",
                         Tab[5][IndC][Ind], ",", Tab[6][IndC][Ind], ",")
               #end
               #local Ind = Ind + 1;
          #end
          #local IndC = IndC + 1;
          M_PVariation(IndC / Nb_Couches, PMax, retour)
     #end
}

#if (Animation = 1)
     #fclose The_File
#end
